<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHouseServiceCost ArrayType
 * @subpackage Arrays
 */
class ArrayOfHouseServiceCost extends AbstractStructArrayBase
{
    /**
     * The item
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\HouseServiceCost[]
     */
    public $item;
    /**
     * Constructor method for ArrayOfHouseServiceCost
     * @uses ArrayOfHouseServiceCost::setItem()
     * @param \StructType\HouseServiceCost[] $item
     */
    public function __construct(array $item = array())
    {
        $this
            ->setItem($item);
    }
    /**
     * Get item value
     * @return \StructType\HouseServiceCost[]|null
     */
    public function getItem()
    {
        return $this->item;
    }
    /**
     * Set item value
     * @throws \InvalidArgumentException
     * @param \StructType\HouseServiceCost[] $item
     * @return \ArrayType\ArrayOfHouseServiceCost
     */
    public function setItem(array $item = array())
    {
        foreach ($item as $arrayOfHouseServiceCostItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfHouseServiceCostItemItem instanceof \StructType\HouseServiceCost) {
                throw new \InvalidArgumentException(sprintf('The item property can only contain items of \StructType\HouseServiceCost, "%s" given', is_object($arrayOfHouseServiceCostItemItem) ? get_class($arrayOfHouseServiceCostItemItem) : gettype($arrayOfHouseServiceCostItemItem)), __LINE__);
            }
        }
        $this->item = $item;
        return $this;
    }
    /**
     * Add item to item value
     * @throws \InvalidArgumentException
     * @param \StructType\HouseServiceCost $item
     * @return \ArrayType\ArrayOfHouseServiceCost
     */
    public function addToItem(\StructType\HouseServiceCost $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HouseServiceCost) {
            throw new \InvalidArgumentException(sprintf('The item property can only contain items of \StructType\HouseServiceCost, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->item[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HouseServiceCost|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HouseServiceCost|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HouseServiceCost|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HouseServiceCost|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HouseServiceCost|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string item
     */
    public function getAttributeName()
    {
        return 'item';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHouseServiceCost
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
